 /*
borland c++ 4.52
original source www.ee.oulu.fi/~mainfram/lcd.htm 

*/
#include <stdlib.h>
#include <stdio.h>
#include <string.h>
#include <conio.h>
#include <io.h>
#include <dos.h>
#include "font.h"
#include <assert.h>
  //displaytech
#define DISPLAY_ON         0x3f  //0011 1111
#define DISPLAY_OFF        0x3e  //0011 1110
#define DISPLAY_STARTLINE  0xc0  //1100 0000   <<<<<
#define DISPLAY_PAGE_SET   0xb8  //1011 1000
#define DISPLAY_COLUMN_SET 0x40  //0100 0000
 #define DATAREG 0x378    //lpt1   datavyln osoite
 #define CONTROL 0x37A    //  controlvyln osoite
//  #define DATAREG 0x278    //lpt2
//  #define CONTROL 0x27A

/*
The input register is a register that is used for temporarily storing the data to be written
in the display data RAM. The data to be written from the MPU to the input register will be
automatically written in the display data RAM through internal operation.
When the Chip Select is selected and  D/I = 0, the data is written in the register,
synchronized with the fall of signal E.<<<<<<<<
 di=0 == instruction write
 di=1 == data write

ohjaukset muutettu vastaamaan http://www.sunpoint.net/~oh5hrm/lcd.htm mukaista kytkent

*/				                //8421
#define LCD_ENABLE      1   //0001  Inverted PIN !!! = 1010
#define LCD_CS1         0	 //0000  Inverted PIN !!! = 1011
#define LCD_CS2         6   //0110                   = 1101
#define LCD_inst        8   //1000  Inverted PIN !!! = 0011     di tai rs


typedef unsigned char byte;
unsigned char CurrentColumn,DisplayData[8*128+1], CharacterTbl[256*32+1];
unsigned int a,viive;

/* Uses a BIOS function in order to wait a specified number of
 * microseconds. This BIOS functions is only implemented in
 * IBM AT compatible BIOSes (i.e., not in old PC and XT systems)!
 * The timing resolution of this function isn't really down
 * to 1 us on most systems, but it's fine for our purposes.
 */
void wait_us(unsigned long microseconds)
{
  union REGS regs;

  if (microseconds == 0) return;
  regs.h.ah = 0x86;
  regs.x.cx = (int) (microseconds >> 16);
  regs.x.dx = (int) (microseconds & 0xffff);
  int86(0x15, &regs, &regs);
  return;
}

void OmaDelay(void)   //only for DOS appz
 {
wait_us(1);      //	delay(unsigned long microseconds);
 // delay (1);   //	delay(unsigned milliseconds);
 }
/*
  void OmaDelay(void) //optional loop delay
 {

	long aa,a,b=1;
	for(aa=0;aa < viive ;aa++)
	{for(a=0;a < 1024 ;a++) 	b=a/3;}
  }
*/
 void stop(void)
 {
	printf("(press key) \n") ;
	getch();
  //	clrscr();
 }

void output(int port, unsigned char value)
{
outportb(port, value);
}

//rs / di=0 == instruction write
//rs / di=1 == data write
/********************************* 
write timing
E      ---_________-----------____

CS-D/I ======-=================-==

D0-D7  ---------------==========--

**********************************
*/
//        
void SendLCDCommand(byte value, byte CS)
{  
	output(CONTROL,  CS | LCD_inst);  // cs , rs/di = 0 e=1 <<chip select, instruction write , enable yls
	OmaDelay();
//	stop();  //tss pysytetn ohjelman suoritus joten printteri porttiin sytetty arvo voidaan tarkistaa
	output(DATAREG, value);              //bittikuvio datavyln
	OmaDelay();
//	stop();
	output(CONTROL, LCD_ENABLE | CS | LCD_inst);   //cs , rs/di = 0 e=0 <<chip select, instruction write , enable alas
	OmaDelay();
	OmaDelay();
//delay(10);      
//	stop();
	}

void SendLCDData(const unsigned char values[], unsigned int amount)
{
	 byte c_s;
	 int counter;
	 for (counter=0; counter < amount;counter++)
	{
		c_s = CurrentColumn>63?LCD_CS2:LCD_CS1;           //
		output(CONTROL, c_s );   // cs , rs/di = 1 e=1 <<chip select, data write , enable yls
		OmaDelay();
	//	stop();
		output(DATAREG, values[counter]);  //bittikuvio datavyln
		OmaDelay();
	//	stop();
		output(CONTROL, LCD_ENABLE | c_s );  // cs , rs/di = 1 e=0 <<chip select, data write , enable alas
		OmaDelay();


 //		stop();

		CurrentColumn++;
		if (CurrentColumn > 127)
			return;
	}
}

void SetColumn(unsigned char y)
{

	 assert(y < 128);
	 CurrentColumn = y;
	 if (y < 64)
	{
		SendLCDCommand(DISPLAY_COLUMN_SET | (y&63), LCD_CS1);

		SendLCDCommand(DISPLAY_COLUMN_SET | 0, LCD_CS2);

	 } else
	{
		SendLCDCommand(DISPLAY_COLUMN_SET | 63, LCD_CS1);

		SendLCDCommand(DISPLAY_COLUMN_SET | ((y-64)&63), LCD_CS2);

	 }
}

void SetPage(unsigned char x)
{
	 assert( x < 8);
	SendLCDCommand(DISPLAY_PAGE_SET | x, LCD_CS1);
	SendLCDCommand(DISPLAY_PAGE_SET | x, LCD_CS2);
}

void SetStartLine(unsigned char line)
{
	SendLCDCommand(DISPLAY_STARTLINE | (line & 63), LCD_CS1);
	SendLCDCommand(DISPLAY_STARTLINE | (line & 63), LCD_CS2);
}

 	

void putpixel(unsigned int x, unsigned int y, unsigned char toggle)
{
	DisplayData[(x&127)+(((y&63) >> 3) << 7)] |= 1 << (y & 7);
}

void LCDprintf(unsigned char y, unsigned char page, char *Str,...)
{
	unsigned char n;

	 SetColumn(y);
	SetPage(page);
	 SetColumn(y);

	for (n = 0;n < strlen(Str);n++)
	{
		  SendLCDData(&Character8x8[*(Str+n)*8], 8);
	}
}
/*
void LCDprintf2(unsigned char y, unsigned char page, char *Str,...)
{
	unsigned char n;
	  //	 SetColumn(y);
  //	SetPage(page);
  //	 SetColumn(y);

	for (n = 0;n < strlen(Str);n++)
	{
		  SendLCDData(&Character8x8[*(Str+n)*8], 8);
	}
}
*/

void write0(void)
{
 outportb(DATAREG, 0);    //kaikki bitit ...
 outportb(CONTROL, 11);   // 0-tilaan
}
void test(void)
{
output(CONTROL,  LCD_ENABLE);
stop();
output(CONTROL,  LCD_CS1);
stop();
output(CONTROL,  LCD_CS2);
stop();
output(CONTROL,  LCD_inst );
stop();
output(CONTROL,  LCD_CS1 | LCD_inst);
stop();
output(CONTROL, LCD_ENABLE | LCD_CS1 | LCD_inst);
stop();
output(CONTROL,  LCD_CS2 | LCD_inst);
stop();
output(CONTROL, LCD_ENABLE | LCD_CS2 | LCD_inst);
stop();

}
start()
{
OmaDelay(); 
output(CONTROL, LCD_ENABLE  |  LCD_CS1); 
OmaDelay(); 
}
void main(void)
{
	  unsigned char x, value,  c, aa;
		 int bb;
	  int b;

	 value = 0x0;

//	 write0();
start();
//	 test();
	 /*/////////////////7
	 printf("============\n");
	 stop();
	 LCDprintf2(0,0,"==");

	 /////////////////*/
/* // not used
	 printf("anna viive(0-255) ja paina enter\n");
	 scanf("%d",&viive);
		  printf("viive on %d \n",viive);
*/	 /////////////////
/*
	for(aa=0;aa < viive ;aa++)
	 {
		printf("luuppaa %d ",aa);
		for(c=0;c < 255 ;c++)
	  {	bb=c/3;}
	 }
*/
		printf("alustetaan lcd...please wait \n ");
	 ///////////////
	// printf("cs1\n");
	 SendLCDCommand(DISPLAY_ON, LCD_CS1);
	// printf("cs2\n");
	 SendLCDCommand(DISPLAY_ON, LCD_CS2);
  //	 printf("SetStartLine\n");
	  SetStartLine(0);
  //	  printf("8x128 looppi\n");
	  for (x=0;x < 8;x++)
	  {
		  SetPage(x);SetColumn(0);
		  for (a = 0 ;a < 128; a++)
			 SendLCDData(&value, 1);
	  }
  //	  printf("SetStartLine\n");
	 SetStartLine(0);

	  printf("============\n");
	  LCDprintf(0,0,"================");
	  LCDprintf(0,1,"    128 x 64    ");
	  LCDprintf(0,2," dot matrix LCD ");
	  LCDprintf(0,3,"================");
	  printf("    128 x 64  \n") ;
	  printf("dot matrix lcd \n")  ;
	  printf("================\n") ;
	 // getch();

	  LCDprintf(0,5,"    HW&SW by    ");
	 LCDprintf(4,6,"  Ilkka Jauho  ");
		 printf("    HW&SW by  \n") ;
		printf("ilkka jauho \n") ;
	 // getch();

	  LCDprintf(0,5,"   SCROLLING... ");
	 LCDprintf(0,6,"   *********    ");
			printf("********* (press any key) \n")   ;
		a = 0;
	  while (!kbhit())  //oottaa keypressi
	 {
		SetStartLine(a++);
		b = 1000;
			while (b--) OmaDelay();
	 }
    write0();

}

